/**
 * Author: jmartisk
 * Date: 1/25/12
 * Time: 5:36 PM
 */
def jbossHome = System.getProperty("jboss.home")
assert jbossHome != null, "please specify property: jboss.home"
def iterations = System.getProperty("iterations")
assert iterations != null, "please specify property: iterations"

STANDALONE_CONFIG = System.getProperty("standalone.config", "standalone-full.xml")
DEPLOYMENT_FILE = System.getProperty("deployment.file")

int iters = (Integer.parseInt(iterations))
Process p
int iteration = 1
int memory_before
int memory_after
try {
    println "************ RUNNING STANDALONE EAP INSTANCE ************"
    p = EapCommonTools.runStandaloneEAP(jbossHome, STANDALONE_CONFIG)
    EapCommonTools.waitUntilStandaloneEapHasStarted(jbossHome,  p)

    String name
    if(DEPLOYMENT_FILE.contains("/"))
        name = DEPLOYMENT_FILE.substring(DEPLOYMENT_FILE.lastIndexOf("/")+1)
    else
        name = DEPLOYMENT_FILE

    iters.times {
        println "################### ITERATION NUMBER $iteration/$iters"
        runtimeName  = EapCommonTools.deployFile(jbossHome, DEPLOYMENT_FILE, name)
        EapCommonTools.getFinishedDeploymentLogFor("$jbossHome/standalone/log/server.log", runtimeName)
        EapCommonTools.undeployFile(jbossHome, runtimeName)
        Thread.sleep(3000)
        iteration++
    }

    println "************ STOPPING SERVER ************"
    EapCommonTools.stopStandaloneEAP(jbossHome, p, 4)

} catch (Exception e) {
    println "************ STOPPING SERVER (CAUGHT EXCEPTION) ************"
    e.printStackTrace()
    EapCommonTools.stopStandaloneEAP(jbossHome, p, 4)
    throw e
}

System.exit(0)
